unit uCleanUp;

{$MODE Delphi}

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileUtil, ShellAPI;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
  private
    sr: TSearchRec;
    function GetXML(path: String; ext: String): String;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure SendToRecycleBin(FileList: TStrings; Dlg: boolean);forward;

procedure TForm1.FormCreate(Sender: TObject);
// フォーム初期化時
var
  FileName: String;
  Attr: Word;
begin
  // ドラッグ＆ロップのプロパティをTrueにする
  Self.AllowDropFiles := True;

  // パラメータをチェック
  if paramcount >=1 then begin  //何か引数があるか確認
      FileName := paramstr(1);
      Attr := FileGetAttr(FileName);
      if (Attr and faDirectory)=faDirectory then
          Edit1.Text := SysToUTF8(FileName)
      else
          Edit1.Text := ExtractFileDir(SysToUTF8(FileName));
  end else begin
      edit1.Text := SysToUTF8(GetCurrentDir);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
// ファイルリストを作成してゴミ箱に入れる
var
  Flist :TStrings;
  DirName: String;
  osInfo: OSVERSIONINFO;
  fname: String;
begin
  //OSのバージョン情報を取得
  osInfo.dwOSVersionInfoSize:=sizeof(OSVERSIONINFO);
  GetVersionEx(osInfo);

  if edit1.Text = '' then
    DirName := SysToUTF8(GetCurrentDir)
  else
    DirName := edit1.Text;

  Flist := TStringlist.Create;
  try
    if osInfo.dwMajorVersion > 4 then begin
        //Windows2000 以上
        fname := GetXML(DirName, '.dll');
        while fname<>'' do begin
          fname := DirName + '\' + fname;
          if FileExists(UTF8ToSYS(fname)) then
            Flist.Add(fname);
          fname := GetXML('', '.dll');
        end;
        fname := GetXML(DirName, '.exe');
        while fname<>'' do begin
          fname := DirName + '\' + fname;
          if FileExists(UTF8ToSYS(fname)) then
            Flist.Add(fname);
          fname := GetXML('', '.exe');
        end;
        Flist.Add(DirName + '\*.manifest');
        Flist.Add(DirName + '\*.vshost.exe');
        Flist.Add(DirName + '\*.exe.config');
        Flist.Add(DirName + '\*.pdb');
    end;
    Flist.Add(DirName + '\*.~b*');
    Flist.Add(DirName + '\*.~d*');
    Flist.Add(DirName + '\*.~t*');
    Flist.Add(DirName + '\*.~pa');
    Flist.Add(DirName + '\*.bak');
    Flist.Add(DirName + '\*.dcu');
    Flist.Add(DirName + '\*.o');
    Flist.Add(DirName + '\*.obj');
    Flist.Add(DirName + '\*.ilc');
    Flist.Add(DirName + '\*.ild');
    Flist.Add(DirName + '\*.ilf');
    Flist.Add(DirName + '\*.ils');
    Flist.Add(DirName + '\*.tds');
    Flist.Add(DirName + '\*.jw$');
    Flist.Add(DirName + '\*.$oc');
    Flist.Add(DirName + '\*.ppu');
    Flist.Add(DirName + '\*.or');
    Flist.Add(DirName + '\*.compiled');
    Flist.Add(DirName + '\*.suo');
    Flist.Add(DirName + '\*.*~');
    SendToRecycleBin(FList, true);
  finally
    Flist.free;
  end;
  Close;
end;

procedure SendToRecycleBin(FileList: TStrings; Dlg: boolean);
// ファイルリストのファイルをゴミ箱に移動する
var
  LpFileOp:TSHFILEOPSTRUCT;
  FileNames: string;
  //i: integer;
  osInfo: OSVERSIONINFO;
begin
  //OSのバージョン情報を取得
  osInfo.dwOSVersionInfoSize:=sizeof(OSVERSIONINFO);
  GetVersionEx(osInfo);

  if FileList.Count = 0 then exit;
  // #0をデリミタとした文字列を作る
  FileList.Delimiter := #0;
  FileNames := FileList.DelimitedText;
  //for i := 0 to FileList.Count - 1 do
  //  FileNames := FileNames + FileList[i] + #0;
  // ターミネイタにもう一度#0をつける
  FileNames := FileNames + #0;
  //内容を確認
  //FileList.Delimiter := #13;
  //ShowMessage(FileList.DelimitedText);
  try
  with LpFileOp do begin
    Wnd := Application.MainFormHandle;
    wFunc := FO_DELETE;
    pFrom := PChar(UTF8ToSys(FileNames));
    pTo:= nil;
    fFlags := FOF_ALLOWUNDO;
    if not Dlg then fFlags := fFlags or FOF_SILENT;
    hNameMappings := nil;
    lpszProgressTitle := nil;
  end;
  SHFileOperation(LpFileOp); // 実行
  except
  ShowMessage('Error');
  end;
  // ゴミ箱アイコンのリフレッシュ
  if osInfo.dwMajorVersion > 5 then begin
    //Windows7 以上（Vista含む）
    FileNames := '' + #0; // nilをコピーする
    with LpFileOp do begin
      Wnd := Application.MainFormHandle;
      wFunc := FO_DELETE;
      pFrom := PChar(FileNames);
      pTo:= nil;
      fFlags := FOF_ALLOWUNDO;
      if not Dlg then fFlags := fFlags or FOF_SILENT;
      hNameMappings := nil;
      lpszProgressTitle := nil;
    end;
    SHFileOperation(LpFileOp); // 実行
    Application.ProcessMessages;
    // デスクトップのリフレッシュ
    SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
  end;
end;

procedure TForm1.FormDropFiles(Sender: TObject; const FileNames: array of String
  );
// ドロップしたファイルがフォルダーならエディットボックスに入れる
var
  Attr: Word;
begin
  Attr := FileGetAttrUTF8(FileNames[0]); { *Converted from FileGetAttr*  }
  if (Attr and faDirectory)=faDirectory then
    Edit1.Text := FileNames[0]
  else
    Edit1.Text := ExtractFileDir(FileNames[0]);
end;

function TForm1.GetXML(path: String; ext: String): String;
// 削除すべきXMLファイルを検索する
begin
  Result := '';
  if path <> '' then begin
    path := path + '\*' + ext;
    if FindFirst(UTF8ToSYS(path), faAnyFile, sr) = 0 then begin
      Result := ChangeFileExt(sr.Name, '.xml');
    end;
  end else begin
    if FindNext(sr) = 0 then begin
      Result := ChangeFileExt(sr.Name, '.xml');
    end;
  end;
end;

end.
